// ps4000wrap.cpp : Defines the entry point for the DLL application.
//
#include <windows.h>
#include <stdio.h>
#include "ps4000Api.h"

short _ready;
short _autoStop;
unsigned long _numSamples;
unsigned long _triggeredAt = 0;
short _triggered = FALSE;

void __stdcall StreamingCallback(
    short handle,
		long noOfSamples,
		unsigned long startIndex,
		short overflow,
		unsigned long triggerAt,
		short triggered,
		short autoStop,
		void * pParameter)
{
  _numSamples = noOfSamples;
  _autoStop = autoStop;

	_triggered = triggered;
	_triggeredAt = triggerAt;
  
  _ready = 1;
}

void __stdcall BlockCallback(short handle, PICO_STATUS status, void * pParameter)
{
  _ready = 1;
}

extern short __declspec(dllexport) __stdcall RunBlock(short handle, long preTriggerSamples, long postTriggerSamples, 
            unsigned long timebase, short oversample, short segmentIndex)
{
  _ready = 0;
  _numSamples = preTriggerSamples + postTriggerSamples;

  return (short) ps4000RunBlock(handle, preTriggerSamples, postTriggerSamples, timebase, oversample, 
    NULL, segmentIndex, BlockCallback, NULL);
}

extern short __declspec(dllexport) __stdcall GetStreamingLatestValues(short handle)
{
  _ready = 0;
  _numSamples = 0;
  _autoStop = 0;

  return (short) ps4000GetStreamingLatestValues(handle, StreamingCallback, NULL);
}

// TODO : all of the following functions take a handle but dont use them - should store a dictionary of handles vs results
extern unsigned long __declspec(dllexport) __stdcall AvailableData(short handle)
{
	if( _ready ) return _numSamples;
  return 0l;
}

extern short __declspec(dllexport) __stdcall AutoStopped(short handle)
{
  if( _ready) return _autoStop;
  return 0;
}

extern short __declspec(dllexport) __stdcall IsReady(short handle)
{
  return _ready;
}

extern short __declspec(dllexport) __stdcall IsTriggerReady(short handle, unsigned long *triggeredAt)
{
	if (_triggered)
		*triggeredAt = _triggeredAt;

  return _triggered;
}

extern short __declspec(dllexport) __stdcall ClearTriggerReady(void)
{
	_triggeredAt = 0;
	_triggered = FALSE;
	return 1;
}
